#define LAYOUT_MASK             (1<<0)  /* a 1 bit, shifted left 0 positions */
#define UC_LETTER_MASK          (1<<1)  /* a 1 bit, shifted left 1 position */
#define LC_LETTER_MASK          (1<<2)  /* a 1 bit, shifted left 2 positions */
#define DIGIT_MASK              (1<<3)
#define COMMENT_STOPPER_MASK    (1<<4)
#define OPERATOR_MASK           (1<<5)
#define SEPARATOR_MASK          (1<<6)

#define LETTER_MASK             (UC_LETTER_MASK|LC_LETTER_MASK)
#define LETGIT_MASK             (LETTER_MASK|DIGIT_MASK)

#define bits_of(ch)             (charbits[(ch)&0377])

#define is_end_of_input(ch)     ((ch) == '\0')
#define is_layout(ch)           (bits_of(ch) & LAYOUT_MASK)
#define is_comment_starter(ch)  ((ch) == '#')
#define is_comment_stopper(ch)  (bits_of(ch) & COMMENT_STOPPER_MASK)

#define is_uc_letter(ch)        (bits_of(ch) & UC_LETTER_MASK)
#define is_lc_letter(ch)        (bits_of(ch) & LC_LETTER_MASK)
#define is_letter(ch)           (bits_of(ch) & LETTER_MASK)
#define is_digit(ch)            (bits_of(ch) & DIGIT_MASK)
#define is_letter_or_digit(ch)  (bits_of(ch) & LETGIT_MASK)
#define is_underscore(ch)       ((ch) == '_')

#define is_operator(ch)         (bits_of(ch) & OPERATOR_MASK)
#define is_separator(ch)        (bits_of(ch) & SEPARATOR_MASK)
