%Start    Comment

Layout              ([ \t])

AnyQuoted           (\\.)
StringChar          ([^"\n\\]|{AnyQuoted})
CharChar            ([^'\n\\]|{AnyQuoted})

StartComment        ("/*")
EndComment          ("*/")
SafeCommentChar     ([^*\n])
UnsafeCommentChar   ("*")

%%

\"{StringChar}*\"   {printf("%s", yytext);}    /* string */
\'{CharChar}\'      {printf("%s", yytext);}    /* character */

{Layout}*{StartComment}         {BEGIN Comment;}
<Comment>{SafeCommentChar}+     {}  /* safe comment chunk */
<Comment>{UnsafeCommentChar}    {}  /* unsafe char, read one by one */
<Comment>"\n"                   {}  /* to break up long comments */
<Comment>{EndComment}           {BEGIN INITIAL;}

.                   {printf("%s", yytext);}    /* all the rest */
