#define N_OPERATORS     2
static const char operator_list[N_OPERATORS] = {'+', '*'};

typedef enum {none, cst, mem, reg, reg_7, reg_8, max_location} Location;

#define N_BASIC_LOCATIONS   2
static Location basic_location_list[N_BASIC_LOCATIONS] = {cst, mem};

#define N_ACTUAL_LOCATIONS  3
static Location actual_location_list[N_ACTUAL_LOCATIONS] = {cst, mem, reg};

static char *
location2string(Location op) {
    switch (op) {
    case none: return "none";
    case cst: return "cst";
    case mem: return "mem";
    case reg: return "reg";
    case reg_7: return "reg_7";
    case reg_8: return "reg_8";
    case max_location: return "max_location";
    default: return "<<<< Bad Location value >>>>";
    }
}

typedef struct {
    char *name;
    char operator;
    Location operand, second_operand;
    Location result;
    int cost;
} Instr;

static const Instr instr_list[] = {
    {"#1", ' ', cst, none, reg, 1},
    {"#2", ' ', mem, none, reg, 3},

    {"#3", '+', reg, mem, reg, 3},
    {"#4", '+', reg, reg, reg, 1},
    {"#7", '+', reg, reg_7, reg, 4},

    {"#5", '*', reg, mem, reg, 6},
    {"#6", '*', reg, reg, reg, 4},
    {"#7.1", '*', cst, reg, reg_7, 0},
    {"#8", '*', reg, reg_8, reg, 5},
    {"#8.1", '*', cst, reg, reg_8, 0},

    {0, ' ', none, none, none, 0}
};
